aboutsummaryrefslogtreecommitdiff
path: root/bin/netfileget
diff options
context:
space:
mode:
Diffstat (limited to 'bin/netfileget')
-rwxr-xr-xbin/netfileget32
1 files changed, 32 insertions, 0 deletions
diff --git a/bin/netfileget b/bin/netfileget
new file mode 100755
index 00000000..1b39f0f3
--- /dev/null
+++ b/bin/netfileget
@@ -0,0 +1,32 @@
+#!/usr/local/plan9/bin/rc
+
+f=getfile
+if(~ $1 -d){
+ f=getdir
+ shift
+}
+
+if(! ~ $#* 2){
+ echo 'usage: netget [-d] system path' >[1=2]
+ exit usage
+}
+
+t=/tmp/netget.$pid.$USER
+fn sigexit { rm -f $t }
+
+fn getfile {
+ rm -f $t
+ if(! echo get $2 $t | sftp -b - $1 >/dev/null)
+ exit 1
+ cat $t
+}
+
+fn getdir {
+ if(! {echo cd $2; echo ls -l} | sftp -b - $1 | sed '1,2d; s/sftp> //g; /^$/d' >$t)
+ exit 1
+ cat $t | awk '$NF == "." || $NF == ".." { next } {s = $NF; if($0 ~ /^d/) s = s "/"; print s}'
+}
+
+$f $1 $2
+exit 0
+